/*	inp.c	for arper2	*/
/*	1997/02/26	Rick	*/

#include	<corlib.h>

extern char	inpbuf[], tit[];

int	inpexec( WindowID, EventInfo* );
int	inpwin( WindowID, EventInfo* );

inpexec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[60], *dp=dbuf;
	static	InputClass	input;
	
	switch( info->option ){
	case EventOpen:
		InputSet( &input, 10, 30, inpbuf, 40, 9, 12 );
		*inpbuf= '\0';
		WindowRedraw( wp );
		WindowSetEventAttr( wp, EventAttrDefault|EventUserON );
		return	TRUE;
	case EventClose:
		WindowClose( wp );
		return TRUE;
	case EventRedraw:
		DrawSetClear( dp++, 1 );
		DrawSetSymbol( dp++,   5,  5,      tit,          13, 16 );
		DrawSetSymbol( dp++,  30, 50, " s ", AttrDefault, 12 );
		DrawSetSymbol( dp++, 110, 50, " ~ ", AttrDefault, 12 );
		DrawSetLine( dp++,  28, 48,  67, 63, ShadowUp, OptionShadow );
		DrawSetLine( dp++, 108, 48, 147, 63, ShadowUp, OptionShadow );
		DrawSetLine( dp++,   8, 28, 251, 43, ShadowDown, OptionShadow );
		dp+= InputSetDraw( dp, &input );
		WindowDraw( wp, dbuf, dp-dbuf );
		return	TRUE;
	case EventKey:
		WindowDraw( wp, dbuf, InputKey( dbuf, &input, info->KeyCode, info->ShiftStat ) );
		return TRUE;
	case EventMouseEnter:
	case EventMouseOut:
		WindowDraw( wp, dbuf, InputSetCursorVisible( dbuf, &input, info->option == EventMouseEnter ) );
		return TRUE;
	case EventUser:
		switch( info->ComData ){
		case UserPaste:
		case UserString:
			return	ClipGetKeyboardAll( wp, info );
		}
		return FALSE;
	}
	return	FALSE;
}

int	inpwin( wp, info )
WindowID	wp;
EventInfo	*info;

{
	WindowID	pwp, cwp, nwp;

	pwp= WindowGetParent( wp );
	if( pwp== WindowRootID ){ pwp= WindowGetChildTop( wp ); }
	cwp= WindowSimpleOpen( 200, 200, 260, 75, NULL, inpexec );

	for(;;){
		if( !WindowGetEventInfo( info ) ){
			continue;
		}
		nwp= WindowGetChild( WindowRootID, info );
		if( nwp == cwp ){
			if( info->LeftON ){
				if( info->y >48 && info->y < 63 ){
					if( info->x > 28 && info->x < 67 ){
						break;
					}else {	if( info->x >108 && info->x < 147 ){
							*inpbuf= '\0';
							break;
						}
					}
				}
			}else { if( info->option == EventKey ){
					if( info->KeyCode == '\r' ){
						break;
					}
				}
			}
		}
		if( nwp != NULL ){
			if( nwp != wp && nwp != pwp ){
				WindowSendEvent( nwp, info );
			}
		}
	}
	WindowClose( cwp );
	return TRUE;
}
