/*				analyze4.c					*/
/*	for arper.win the fourth revolution		*/
/*			1998/09/07	Rick				*/

#include	<mm_alloc.h>
#include	<corlib.h>
#include	<string.h>
#include	<direct.h>
#include	"arper.h"

extern char	spool[];
extern int	(*headreader)( char*, char*, FILE* );
extern int	typelzh;

store	*tmpfil;
int	maxptr;
unsigned char	maxno;

extern int	getlzhhead( FILE* );

int	listopen( arpbox* );
int	analyze( arpbox*, char* );
void	sort( arpbox* );


int
listopen( cl )
arpbox	*cl;
{
	char	*tp;
	unsigned char	buf[1024];
	FILE	*fp;
  
	if( !( fp= fopen( cl->arcfile, "rb" ) ) ){
		return 0;
	}
	if( typelzh ){
		if( !getlzhhead( fp ) ){
			fclose( fp );
			return 0;
		}
	}
	tp= strcpyr( strcpyr( cl->base, spool ), itoa( cl->clno, buf, 10 ) );
	mkdir( cl->base );
	cl->baselen= tp- cl->base + 1 ;
	cl->count= 1;
	cl->stptr= malloc( sizeof(store)*MAXENTRY );
	cl->filptr= malloc( sizeof(store*)*MAXENTRY );
	maxno= 1;
	maxptr= 0;
	*( cl->filptr )= cl->stptr;
	tmpfil= cl->stptr;
	strcpyr( strcpyr( tmpfil->name, cl->base ), "\\\\" );
	tmpfil->data[6]= 0;	/*size=childnum*/
	strcpyr( tmpfil->data, "<dir>" );
	tmpfil->data[8]= 1;	/*time=dirID*/
	tmpfil->no= 0;
	tmpfil->flag= 9;
	tmpfil++;
	while( headreader( buf, tmpfil->data, fp ) ){
		tmpfil->flag= 9;
		tp= strchr( buf, '\0' );
		if( *buf && *(tp - 1) != '/' ){
			if( !analyze( cl, buf ) ){
				ConsoleOpen();
				ConsolePrint( "arper : over 255 entries\n" );
				break;
			}
		}
	}
	fclose( fp );	
	return 1;		/*read ok*/
}

int
analyze( cl, name )
arpbox	*cl;
char	*name;
{
	store	*parent= *(cl->filptr),
		**j, *regfil;
	char	*tp, *np, *ep,
		dirn[32]="\0",
		tbuf[88];
	unsigned char	pno;
	int	i,
		dirregflag,
		childnum= (**(cl->filptr)).data[6];
	
	regfil= tmpfil;
	ep= strcpyr( tbuf, cl->base );
	tp= name;
	while( 1 ){
		pno= parent->data[8];
		if( !( np= strchr( tp, '/' ) ) ){
			ep= strcpyr( regfil->name, tbuf );
			*ep++= '\\';
			regfil->fname= ep;
			strcpyr( ep, tp );
			regfil->no= pno;
			++maxptr;
			*(cl->filptr + maxptr)= regfil;
			parent->data[6]++;
			sort( cl );
			if( ++cl->count == MAXENTRY-1 ) return FALSE;	/*filereg*/
			tmpfil++;
			return	TRUE;
		}
		*np= '\0';
		strcpyr( dirn, tp );
		*ep++= '\\';
		ep= strcpyr( ep, dirn );
		j= cl->filptr;
		for( i=0; i< maxptr+1; i++ ){	/*eno܂Ŕ*/
			if( ((**j).no == pno ))	break;
			j++;
		}
		dirregflag= TRUE;
		if( i != maxptr+1 ){
			for( i= 0; i< childnum; i++ ){
				if( (**j).data[0] == '<' && !( strcmp( (**j).fname, dirn ) ) ){
					parent= *j;
					childnum= (**j).data[6];
					dirregflag= FALSE;
					break;
				}
				j++;
			}
		}
		if( dirregflag ){
			tmpfil++;
			strcpyr( tmpfil->name, tbuf );
			tmpfil->fname= strrchr( tmpfil->name, '\\' )+1;
			tmpfil->data[6]= 0;
			childnum= 0;
			strcpyr( tmpfil->data, "<dir>" );
			tmpfil->data[8]= ++maxno;
			tmpfil->no= pno;
			tmpfil->flag= 9;
			++maxptr;
			*(cl->filptr + maxptr )= tmpfil;
			parent->data[6]++;
			parent= tmpfil;
			sort( cl );
			if( ++cl->count == MAXENTRY-1 ) return FALSE;
		}
		tp= np+1;
	}
	return TRUE;
}

void
sort( cl )
arpbox	*cl;
{
	store	**t, **ii, **tmp= cl->filptr + maxptr,
		*hold= *tmp;
	int	i, ptr;
	unsigned char	parentno;

	t= tmp;
	parentno= (**tmp).no;	/*ǉt@C̐edir_no*/
	ptr= maxptr;

	while( 1 ){
		--ptr;
		--t;
		if( (**t).no <= parentno ){
			ii= tmp;
			for( i= maxptr ; i>ptr+1 ; i-- ){
				*ii= *(ii-1);
				ii--;
			}
			*(t+1)= hold;
			break;
		}
	}
	return;
}

