/* Archive Peeker for Ko-window	*/
/*	version 0.41	1998/09/08	*/
/*	Copyright S.Honma (Rick)	*/

#include	<mm_alloc.h>
#include	<corlib.h>
#include	<winop.h>
#include	<string.h>
#include	<HS_wlib.h>
#include	"arper.h"

int	WindowHeapSize= 1024 * 6;

int	menunum, extnum, arpnum= 0;
char	spool[64]="\0",
	*menu[16], menustr[256]= "\0",
	*mecop[16], menucom[2048]= "\0",
	*extpack[32], extstr[96]= "\0",extcom[3072]= "\0",
	inpbuf[42], tit[20],
	client[32][88], nbuf[88];
int	(*headreader)( char*, char*, FILE* );
int	typelzh;
WindowID	Cwp;

extern int	listlzh( char*, char*, FILE* );
extern int	listzip( char*, char*, FILE* );
extern int	listopen( arpbox* );
extern store	**jump( arpbox*, store** );
extern int	cnfload();
extern int	ExecA( WindowID, EventInfo* );
extern int	ExecB( WindowID, EventInfo* );

int	preexec( WindowID, EventInfo* );
int	trueopen( arpbox* );
void	newarp( char*, WindowID );
int	WindowMain( int, char** );

int	preexec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[2];
	char	filename[88];
	
	switch( info->option ){
	case EventOpen:
		cnfload();
		WindowRedraw( wp );
		WindowSetEventAttr( wp, EventAttrDefault|EventUserON );
		return	TRUE;
	case EventRedraw:
		DrawSetClear( dbuf, 1 );
		DrawSetSymbol( dbuf+1, 6, 0, "Let me see!", AttrDefault, 12 );
		WindowDraw( wp, dbuf, 2 );
		return	TRUE;
	case EventClose:
		WindowClose( wp );
		WindowConnectionClose();
		return	TRUE;
	case EventUser:
		switch( info->ComData ){
		case UserPaste:
		case UserString:
			PathGetFullName2( filename, info->ComBuffer );
			newarp( filename, wp );
			return TRUE;
		case UserStrings:
			PathGetFullName2( filename, *(char**)info->ComBuffer );
			newarp( filename, wp );
			return TRUE;
		}
		return FALSE;
	}
	return	FALSE;
}

int
trueopen( cl )
arpbox	*cl;
{
	unsigned int	i;
	char	arcext[4];
	
	for( i= 0; i< 32; i++ ){
		if( !(client[i][0]) ){
			strcpyr( client[i], cl->arcfile );
			cl->clno= i;
			break;
		}
		if( !stricmp( client[i], cl->arcfile ) )
			return FALSE;
	}
	if( i == 32 ){
		ConsoleOpen();
		ConsolePrint( "arper : too many ArPers\n" );
		return FALSE;
	}
	stcgfe( arcext, cl->arcfile);
	if( !stricmp( arcext, "lzh" ) || !stricmp( arcext, "X" ) ){
		strcpyr( cl->archiver, "lx.r" );
		headreader= listlzh;
		typelzh= TRUE;

	}else if ( !stricmp( arcext, "zip" ) ){
		strcpyr( cl->archiver, "zx.r" );
		headreader= listzip;
		typelzh= FALSE;
	}else {
		return	FALSE;
	}
	if( listopen( cl ) != 1 ){
		ConsoleOpen();
		ConsolePrint( "arper : archive error\n" );
		return FALSE;
	}
	cl->endptr= cl->count + cl->filptr;
	cl->parent= 1;
	cl->parptr= cl->stptr;
	cl->nowct= (cl->parptr)->data[6];
	cl->nowptr= jump( cl, cl->filptr );
	i= cl->nowct * 12;
	if( i <= cl->v - 30 ){ i= cl->v - 30; }
	cl->Awp= WindowTitleOpen( cl->x, cl->y, cl->h, cl->v, NULL, "ArPer4", Resize|Close|Push, ExecA );
	WindowSetEventAttr( cl->Awp, EventAttrDefault|EventUserON );
	WindowSetClientData( cl->Awp, 0, cl );
	cl->Bwp= WindowScrollOpen( 0, 24, cl->h, cl->v-24, cl->Awp, 326, i, DirectionX|DirectionY, 16, 12, ExecB );
	WindowSetEventAttr( cl->Bwp, EventAttrDefault );
	WindowSetClientData( cl->Bwp, 0, cl );
	WindowRedraw( cl->Awp );
	arpnum++;
	return	TRUE;
}

void
newarp( newname, wp )
char	*newname;
WindowID wp;
{
	arpbox	*cl;

	cl= malloc( sizeof( arpbox) );
	cl->x= HS_WindowGetPositionX( wp );
	cl->y= HS_WindowGetPositionY( wp );
	if( wp == Cwp ){
		cl->h= 146;
		cl->v= 194;
	}else {
		cl->h= HS_WindowGetViewSizeX( wp );
		cl->v= HS_WindowGetViewSizeY( wp );
	}
	strcpyr( cl->arcfile, newname );
	if( !trueopen( cl ) )	free( cl );
	return;
}

int
WindowMain( argc, argv )
int	argc;
char	**argv;
{
	int	pid, pct= -1, Deffile= FALSE;
	char	*tp, pname[]= "arper.win";
	int	x= 154, y= 0, h= 146, v= 194;
	
	argc= AnalyzeArgs( argc, argv, &x, &y, &h, &v );
	if( h > 326 ) h= 326;
	for( ; --argc ;){
		if( **++argv != '-' ){
			PathGetFullName2( nbuf, *argv );
			Deffile= TRUE;
		}
	}
	for( pid= 0; pid= PidSearch( pname, pid+1 ) ; ) pct++;
	if( pct ){
		if( Deffile )	UserSendExec( pname, NULL, nbuf );
		WindowConnectionClose();
	}else {
		tp= KoWindowGetEnv( "spool" );
		if( tp== NULL ){ 
			tp= getcwd( spool, 64 );/* \Ă*/
		}else {
			tp= strcpyr( spool, tp ); 
		}
		if(*(tp-1)!='\\'){
			*tp= '\\';
			*(tp+1)= '\0';
		}
		Cwp=WindowTitleOpen( x, y, 80, 16, NULL, "ArPer4", Close|Push, preexec );
		if( Deffile ){ 
			newarp( nbuf, Cwp );
		}
	}
	return	TRUE;
}
